/**
 * Created by litao on 2018/8/9.
 */
'use strict';
module.exports = function(Vue, customComponentsContext) {
    let components = require.context('./', true, /\.vue$/);

    while (components) {
        componentsHandler(Vue, components);
        components = customComponentsContext;
        customComponentsContext = undefined;
    }
};

function componentsHandler(Vue, components) {
    components.keys().forEach(function (item) {
        let component = components(item);
        if(component && component.default){
            let componentName = component.default.registryName || component.default.componentName || item;
            if(componentName){
                Vue.component(componentName, component.default);
                _console.log('%c注册全局组件: %s', "color: red;", componentName);
            }
        }
    });
}