/**
 * Created by litao on 2018/9/20.
 */

export default {
    /**
     * textarea展示字符限制提示
     */
    textAreaValidTip: {
        bind: changeTextAreaTip,

        componentUpdated: changeTextAreaTip
    }
}

function changeTextAreaTip (el, binding, vnode, oldVnode){
    let max = binding.value;
    let instance = vnode.componentInstance;

    if(instance && max){
        let valueLength = (instance.value || '').length;

        let isError = valueLength > max;

        generateTipDom(`${valueLength}/${max}`, isError);
    }


    function generateTipDom(tipMsg, isError) {
        let domId = `${instance._uid}-textarea-tip-dom`;
        let dom = document.getElementById(domId);
        if(!dom){
            dom = document.createElement('div');
        }

        dom.innerHTML = tipMsg;
        dom.id = domId;
        dom.classList.add('textarea-tip-dom_error');

        if(isError){
            dom.style.color = 'red';
        }else{
            dom.style.color = '#606266';
        }
        el.appendChild(dom);
    }
}