/**
 * Created by litao on 2018/9/30.
 */
import Vuex from 'vuex';
import menu from './modules/menu';
import user from './modules/user';
import Utils from '../../utils/index';

class GlobalState {
    constructor (Vue, modules){
        Vue.use(Vuex);

        let mergeModules = Object.assign(modules || {}, {
            menu,
            user
        });

        let instance = new Vuex.Store({
            modules: mergeModules,
            getters: this.initGettersByModules(mergeModules)
        });

        window.__JBootInstance__ = instance._vm;

        return instance;
    }

    /**
     * 初始化内置的getters
     * @param modules 模块
     * @param getters 自定义getters
     */
    initGettersByModules (modules = {}){
        let resultGetters = {};

        Object.keys(modules).forEach(moduleKey => {
            let module = modules[moduleKey].state;

            Utils.assert(module && Utils.equalsType(module, Object), '全局状态的模块属性必须包裹在state下，不可直接声明');

            Object.keys(module).forEach(stateField => resultGetters[stateField] = state => state[moduleKey][stateField]);
        });

        return resultGetters;
    }
}
export default GlobalState;