/**
 * Created by litao on 2018/9/30.
 */
export default {
    state: {
        menuInfo: {
            initErrorCode: undefined, //初始化异常code
            constantPages: [], //包括login、404、401、500页面
            menuSource: [], //原始菜单
            successMenus: [], //可以访问的菜单
            serverMenus: [] //服务器返回的菜单
        }
    },

    mutations: {
        MENU_INIT_ERROR: function (state, errorCode) {
            state.menuInfo.initErrorCode = errorCode;
        },

        SAVE_MENU: function (state, { type, menus = [] }) {
            if(!Object.keys(state.menuInfo).includes(type))
                throw new Error(`菜单存储错误，请传入正确类型[${Object.keys(state.menuInfo).join(',')}]`);

            state.menuInfo[type] = menus;
        },

        CLEAR_MENU: (state) => {
            let permission = state.menuInfo.permissionMenus || [];
            state.menuInfo = { permission };
        }
    }
}