/**
 * Created by litao on 2018/9/30.
 */
import VueRouter from 'vue-router';
import Utils from '../../utils/index';

class Router {
    constructor (Vue, hooks, constantPages){
        Vue.use(VueRouter);

        let routerInstance = new VueRouter({
            scrollBehavior: () => ({ y: 0 }),
            routes: constantPages
        });

        this.bindHooks(routerInstance, hooks);

        return routerInstance;
    }

    bindHooks (instance, { before, after }){
        Utils.assert(!before || (before && (Utils.equalsType(before, Function))), '路由beforeHook必须是一个可执行函数');

        Utils.assert(!after || (after && (Utils.equalsType(after, Function))), '路由afterHook必须是一个可执行函数');

        instance.beforeEach(function () {
            before && before(...arguments)
        });
        instance.afterEach(function () {
            after && after(...arguments)
        });
    }
}

export default Router;