/**
 * Created by litao on 2018/9/29.
 */
const Utils = {};

const fns = {
    /**
     * 断言
     */
    assert: function(condition, msg){
        if(!condition)
            throw new Error(msg);

        return condition;
    },

    /**
     * 类型比较
     */
    equalsType: function(obj, type){
        if(type === undefined){
            return obj === type;
        }

        if(obj === undefined){
            return obj === type;
        }

        let typeName = type.name ? type.name.toLowerCase() : type;

        if(obj && type){
            return Object.prototype.toString.call(obj).toLowerCase() === `[object ${typeName}]`;
        }
    },

    /**
     * 初始化字段
     */
    setProperty: function(obj, key, value){
        Object.defineProperty(obj, key, { value });
    },

    /**
     * 在路径中提取名称
     * @param path
     * @return {*}
     */
    extractName: function(path) {
        let pathArray = path.split('/');
        let fileName = pathArray[pathArray.length - 1];
        return fileName.split('\.')[0];
    },

    /**
     * 判断是否为array类型
     * @param obj
     * @return {*|boolean}
     */
    isArray: function(obj){
        return obj && Object.prototype.toString.call(obj).toLowerCase() === '[object array]';
    }
};

/**
 * 工具类属性赋值
 */
Object.keys(fns).forEach(function (fnName) {
    Object.defineProperty(Utils, fnName, {
        value: fns[fnName]
    })
});

export default Utils;